using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Controls;
using System.Globalization;

namespace WindowsApplication4
{
    public class NotNullRule : ValidationRule
    {
        public NotNullRule()
        {
        }
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            if (string.IsNullOrEmpty((string)value))
            {
                return new ValidationResult(false, "͂ĂB");
            }
            return ValidationResult.ValidResult;
        }
    }
}
