using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Collections;


namespace WindowsApplication4
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : System.Windows.Window
    {
        DataSet1 data;

        #region 
        public Window1()
        {
            InitializeComponent();
            ObjectDataProvider provider = (ObjectDataProvider)this.Resources["DataSet1DS"];
            data = (DataSet1)provider.Data;
            data.s{.Gets{Data();
            data.ڋq.GetڋqData();
            InitializeCommands();
        }
        #endregion

        #region R}h\bh
        private void InitializeCommands()
        {
            CommandBinding newCommand = new CommandBinding();
            newCommand.Command = ApplicationCommands.New;
            newCommand.Executed += new ExecutedRoutedEventHandler(newCommand_Executed);
            newCommand.CanExecute += new CanExecuteRoutedEventHandler(newCommand_CanExecute);
            this.CommandBindings.Add(newCommand);

            CommandBinding saveCommand = new CommandBinding();
            saveCommand.Command = ApplicationCommands.Save;
            saveCommand.Executed += new ExecutedRoutedEventHandler(saveCommand_Executed);
            saveCommand.CanExecute += new CanExecuteRoutedEventHandler(saveCommand_CanExecute);
            this.CommandBindings.Add(saveCommand);

            CommandBinding deleteCommand = new CommandBinding();
            deleteCommand.Command = ApplicationCommands.Delete;
            deleteCommand.Executed += new ExecutedRoutedEventHandler(deleteCommand_Executed);
            deleteCommand.CanExecute += new CanExecuteRoutedEventHandler(deleteCommand_CanExecute);
            this.CommandBindings.Add(deleteCommand);
        }

        private bool CanNew()
        {
            DataSet1.ڋqRow row = data.ڋq.FindByID(-1);
            if (row == null) return true;
            return false;
        }

        private void New()
        {
            data.ڋq.NewڋqData();
        }

        private bool CanSave()
        {
            List<DependencyObject> visualChildren = ElementTreeList.GetVisualChildren(this.ڋqListView);
            foreach (DependencyObject child in visualChildren)
            {
                if ((bool)child.GetValue(Validation.HasErrorProperty)) return false;
            }
            if (data.ڋq.GetChanges() == null) return false;
            return true;
        }

        private void Save()
        {
            List<DependencyObject> visualChildren = ElementTreeList.GetVisualChildren(this.ڋqListView);
            foreach (DependencyObject child in visualChildren)
            {
                TextBox textbox = child as TextBox;
                if (textbox != null)
                {
                    BindingExpression be = textbox.GetBindingExpression(TextBox.TextProperty);
                    be.UpdateSource();
                }
            }
            foreach (DependencyObject child in visualChildren)
            {
                if ((bool)child.GetValue(Validation.HasErrorProperty)) return;
            }
            data.ڋq.UpdateڋqData();
        }

        private bool CanDelete()
        {
            if (this.ڋqListView.SelectedItems.Count == 0) return false;
            return true;
        }

        private void Delete()
        {
            data.ڋq.DeleteڋqData(this.ڋqListView.SelectedItems);
        }
        #endregion

        #region R}hCxg
        void newCommand_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = this.CanNew();
            e.Handled = true;
        }

        void newCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            this.New();
            e.Handled = true;
        }

        void saveCommand_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = this.CanSave();
            e.Handled = true;
        }

        void saveCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            this.Save();
            e.Handled = true;
        }

        void deleteCommand_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            e.CanExecute = this.CanDelete();
            e.Handled = true;
        }

        void deleteCommand_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            this.Delete();
            e.Handled = true;
        }
        #endregion
    }
}